summaryrefslogtreecommitdiffstats
path: root/scripts/netconsole
diff options
context:
space:
mode:
authorSascha Hauer <s.hauer@pengutronix.de>2010-06-24 17:37:00 +0200
committerSascha Hauer <s.hauer@pengutronix.de>2010-06-24 17:37:00 +0200
commit485890986b6cff0ff2a1f23ef46cc50451c3110f (patch)
treedfb5cd6d55a245e05fac1b9517f723c6c3181b9c /scripts/netconsole
parent7a1f70e70a8ef9cece22207f9f540624b4d982da (diff)
downloadbarebox-485890986b6cff0ff2a1f23ef46cc50451c3110f.tar.gz
barebox-485890986b6cff0ff2a1f23ef46cc50451c3110f.tar.xz
add netconsole host script
Signed-off-by: Sascha Hauer <s.hauer@pengutronix.de>
Diffstat (limited to 'scripts/netconsole')
-rwxr-xr-xscripts/netconsole59
1 files changed, 59 insertions, 0 deletions
diff --git a/scripts/netconsole b/scripts/netconsole
new file mode 100755
index 0000000000..c8109bb095
--- /dev/null
+++ b/scripts/netconsole
@@ -0,0 +1,59 @@
+#!/bin/sh
+
+usage() {
+ (
+ echo "Usage: $0 <board IP> [board port]"
+ echo ""
+ echo "If port is not specified, '6666' will be used"
+ [ -z "$*" ] && exit 0
+ echo ""
+ echo "ERROR: $*"
+ exit 1
+ ) 1>&2
+ exit $?
+}
+
+while [ -n "$1" ] ; do
+ case $1 in
+ -h|--help) usage;;
+ --) break;;
+ -*) usage "Invalid option $1";;
+ *) break;;
+ esac
+ shift
+done
+
+ip=$1
+port=${2:-6666}
+
+if [ -z "${ip}" ] || [ -n "$3" ] ; then
+ usage "Invalid number of arguments"
+fi
+
+for nc in netcat nc ; do
+ type ${nc} >/dev/null 2>&1 && break
+done
+
+trap "stty icanon echo intr ^C" 0 2 3 5 10 13 15
+echo "NOTE: the interrupt signal (normally ^C) has been remapped to ^T"
+
+stty -icanon -echo intr ^T
+(
+if type ncb 2>/dev/null ; then
+ # see if ncb is in $PATH
+ exec ncb ${port}
+
+elif [ -x ${0%/*}/ncb ] ; then
+ # maybe it's in the same dir as the netconsole script
+ exec ${0%/*}/ncb ${port}
+
+else
+ # blah, just use regular netcat
+ while ${nc} -u -l -p ${port} < /dev/null ; do
+ :
+ done
+fi
+) &
+pid=$!
+${nc} -u ${ip} ${port}
+kill ${pid} 2>/dev/null